#!/usr/bin/ruby
# encoding: utf-8

def get_restore_screen(fwdbutton, simulate)
	outer_box = Gtk::VBox.new(false, 15)
	radio = Array.new
	header = Gtk::Label.new("Ich möchte eine zuvor erstellte Sicherung zurückspielen")
	fat_font = Pango::FontDescription.new("Sans Bold")
	header.modify_font(fat_font)
	desc = Gtk::Label.new("Mit dieser Funktion lässt sich eine gesamte Festplatte Eins zu Eins auf eine zweite Festplatte kopieren (klonen). So können Sie Ihre gesamten Daten samt Windows und allen Programmen sichern oder eine zuvor erstellte Sicherung zurückspielen. Wählen Sie jetzt das Laufwerk, das geklont werden soll (Quelle).") 
	desc.wrap = true
	desc.width_request = 570
	drive_combo = Gtk::ComboBox.new
	reread = Gtk::Button.new("Neu einlesen")
	inner_box = Gtk::HBox.new(false, 0)
	inner_box.pack_start(drive_combo, true, true, 0)
	inner_box.pack_start(reread, false, true, 0)
	outer_box.pack_start(header, true, false, 0)
	outer_box.pack_start(desc, true, true, 0)
	outer_box.pack_start(inner_box, true, true, 0)
	return outer_box, drive_combo, reread
end

def get_restore_target_screen(fwdbutton, simulate)
	outer_box = Gtk::VBox.new(false, 15)
	radio = Array.new
	header = Gtk::Label.new("Auswahl des Ziel-Laufwerks")
	desc = Gtk::Label.new("Wählen Sie jetzt das Ziel-Laufwerk für die Eins zu Eins-Kopie. Achtung: Alle Daten darauf gehen verloren! Das Ziel-Laufwerk muss mindestens so groß sein wie das Quell-Laufwerk. Schließen Sie zum Beispiel eine ausreichend große USB-Festplatte an, und klicken Sie auf \"Weiter\".")
	desc.wrap = true
	desc.width_request = 570
	fat_font = Pango::FontDescription.new("Sans Bold")
	header.modify_font(fat_font)
	drive_combo = Gtk::ComboBox.new
	reread = Gtk::Button.new("Neu einlesen")
	inner_box = Gtk::HBox.new(false, 0)
	outer_box.pack_start(header, true, false, 0)
	outer_box.pack_start(desc, true, true, 0)
	inner_box.pack_start(drive_combo, true, true, 0)
	inner_box.pack_start(reread, false, true, 0)
	outer_box.pack_start(inner_box, true, true, 0)
	return outer_box, drive_combo, reread
end

def get_restore_progress_screen(fwdbutton, simulate)
	outer_box = Gtk::VBox.new(false, 5)
	header = Gtk::Label.new("Klonen einer Festplatte")
	fat_font = Pango::FontDescription.new("Sans Bold")
	header.modify_font(fat_font)
	### desc = Gtk::Label.new("Fortschritt: 42%")
	desc = Gtk::Label.new("Je nach Größe der Festplatte kann der Klonvorgang mehrere Stunden dauern. Bitte brechen Sie ihn nicht ab.")
	desc.wrap = true
	desc.width_request = 570
	pgbar = Gtk::ProgressBar.new
	pgbar.width_request = 570
	scan_vte = Vte::Terminal.new
	scan_vte.set_size(80, 15)
	scan_vte.set_colors(Gdk::Color.new(0,0,0), Gdk::Color.new(65535, 65535, 65535), [])
	stop_button = Gtk::Button.new("Abbrechen")
	stop_button.sensitive = false
	### scan_exp = Gtk::Expander.new("Details anzeigen")
	outer_box.pack_start(header, true, false, 0)
	outer_box.pack_start(desc, true, true, 0)
	outer_box.pack_start(pgbar, true, true, 0)
	### scan_exp.add(scan_vte)
	outer_box.pack_start(scan_vte, true, true, 0)
	outer_box.pack_start(stop_button, true, true, 0)
	return outer_box, scan_vte, pgbar, stop_button
end

def get_restore_finish_screen(fwdbutton, simulate)
	outer_box = Gtk::VBox.new(false, 5)
	header = Gtk::Label.new("Klonen abgeschlossen")
	fat_font = Pango::FontDescription.new("Sans Bold")
	header.modify_font(fat_font)
	desc = Gtk::Label.new("Die Festplatte wurde erfolgreich kopiert. Entfernen Sie nun das Ziel-Laufwerk mit der Komplett-Sicherung, und verwahren Sie es an einem sicheren Ort. Falls Sie eine Komplett-Sicherung zurückgespielt haben, klicken Sie auf „Neu starten“, um Windows zu starten.")
	desc.wrap = true
	desc.width_request = 570 
	reboot = Gtk::Button.new("Computer neu starten")
	reboot.signal_connect("clicked") { Gtk.main_quit }
	sec = Gtk::Label.new
	sec.set_markup("Falls Sie eine Komplett-Sicherung erstellt haben, gibt es zwei Möglichkeiten:\n\n1. Ist Windows beschädigt, kehren Sie zum Hauptmenü zurück und klicken auf \"Windows startet nicht oder stürzt ab\".\n\n2. Ist die Festplatte beschädigt, tauschen Sie sie nun aus. Starten Sie danach die Notfall-CD, um die Komplett-Sicherung zurückzuspielen. Diesmal wählen Sie die Festplatte mit der Sicherung als Quell- und die neue Festplatte als Ziel-Laufwerk. Eine Anleitung zum Festplattentausch finden Sie hier:")
	sec.wrap = true
	sec.width_request = 570 
	pdfbutt = Gtk::Button.new("Anleitung Festplattentausch anzeigen")
	pdfbutt.signal_connect("clicked") { system("evince /lesslinux/cdrom/Anleitungen/Festplattentausch.pdf &") }
	outer_box.pack_start(header, true, false, 0)
	outer_box.pack_start(desc, true, true, 0)
	outer_box.pack_start(reboot, true, true, 0)
	outer_box.pack_start(sec, true, true, 0)
	outer_box.pack_start(pdfbutt, true, true, 0)
	return outer_box
end

def dialog_clone_compare(parent, clone_target, clone_source)
	msg = ""
	moveon = false
	if clone_source.last_partend < 0 && clone_target.size < clone_source.size
		msg = "Das Quelllaufwerk enthält keine Partitionstabelle und ist größer als das Ziellaufwerk - es ist möglich, dass beim Kopieren Daten verloren gehen."
	elsif clone_source.last_partend > clone_target.size
		msg = "Die letzte Partition des Quellaufwerkes liegt hinter dem Ende des Ziellaufwerkes. Es ist möglich, dass beim Kopieren Daten dieser Partition verloren gehen. Wir empfehlen, das Klonen abzubrechen und die letzte Partition des Quelllaufwerkes zunächst zu verkleinern."
	end	
	dialog = Gtk::Dialog.new(
		"Information",
		parent,
		Gtk::Dialog::MODAL,
		[ Gtk::Stock::OK, Gtk::Dialog::RESPONSE_OK ],
		[ Gtk::Stock::CANCEL, Gtk::Dialog::RESPONSE_CANCEL ]	
	)
	dialog.default_response = Gtk::Dialog::RESPONSE_CANCEL
	dialog.has_separator = false
	label = Gtk::Label.new(msg)
	label.wrap = true
	# image = Gtk::Image.new(Gtk::Stock::DIALOG_INFO, Gtk::IconSize::DIALOG)
	# hbox = Gtk::HBox.new(false, 5)
	# hbox.border_width = 10
	# hbox.pack_start_defaults(image)
	# hbox.pack_start_defaults(label)
	dialog.vbox.add(label)
	warn = Gtk::Label.new("Wenn Sie auf \"OK\" klicken, werden alle Daten auf dem Ziellaufwerk überschrieben. Klicken Sie auf \"Abbrechen\" um zurück zur Laufwerksauswahl zu gelangen.")
	warn.wrap = true
	dialog.vbox.add(warn)
	dialog.show_all
	dialog.run { |resp|
		if resp == Gtk::Dialog::RESPONSE_OK
			moveon = true
		end
		dialog.destroy
	}
	return moveon
end

def reread_full_drives(combo, drives_to_ignore)
	drive_meta = Hash.new
	retdrives = Array.new
	99.downto(0) { |i|
		begin
			combo.remove_text(i)
		rescue
		end
	}
	alldrives = AllDrives.new(false, false, false)
	alldrives.dump 
	alldrives.drive_list.each { |k,d|
		unless drives_to_ignore.include?(k) || d.has_mounted_partitions 
			retdrives.push(k)
			combo.append_text(d.device + " " + d.vendor.to_s + " " + d.model.to_s + " " + human_readable_bytes(d.blocks * d.bs) )
			drive_meta[k] = d
		end
	}
	combo.active = 0
	return retdrives, drive_meta
end